'
'Dichiarazioni della variabili globali dell'applicazione
'

Dim sAppPath, sFileReport, sYear, sMonth, sDay
Dim sConnSQL, cnSQL, sQuerySQL

sQuerySQL = "SELECT TOP 20 "
sQuerySQL = sQuerySQL & "OrderID, ProductID, ProductName, ExtendedPrice "
sQuerySQL = sQuerySQL & "FROM Northwind.dbo.[Order Details Extended]"
sQuerySQL = sQuerySQL & "ORDER BY ExtendedPrice DESC "

sYear = cstr(year(date))
if len(cstr(Month(date))) = 1 then sMonth = "0" & cstr(Month(date))
if len(cstr(Day(date))) = 1 then sDay = "0" & cstr(Day(date))

sAppPath = "D:\Documenti\Articoli per il web\Html\Art16\"
sFileReport = sAppPath & "report_"
sFileReport = sFileReport & sYear & sMonth & sDay
sFileReport = sFileReport & ".xls"
sConnSQL = "Provider=SQLOLEDB.1;User ID=sa;Password=caffenograzie;Initial Catalog=Northwind;Data Source=FULCANELLI;Language=Italian" 

'
'Chiamo le routines dell'applicazione
'
Call ApriConnSQL() 'Connessione
Call CreaFoglioExcel() 'Creazione del foglio e copia dei dati
Call ReleaseMemory() 'Rilascio la memoria allocata ed esco

'
'Definisco le routines dell'applicazione
'
Sub ApriConnSQL()
 Set cnSQL = CreateObject("ADODB.Connection")
 cnSQL.Open sConnSQL
end sub

Sub ReleaseMemory()
 If cnSQL.State = 1 Then cnSQL.close()
 Set cnSQL = nothing
End Sub 

Sub CreaFoglioExcel()
On Error Resume Next
 Dim oExcelApplication, oExcelBook, oExcelSheet, oFSO
 Dim aData, rs	
 Set oFSO = CreateObject("Scripting.FileSystemObject")
 if oFSO.FileExists( sFileReport ) then
 	oFSO.DeleteFile sFileReport
 end if
 Set oFSO = Nothing
 Set oExcelApplication = CreateObject("Excel.Application")
 oExcelApplication.visible = False
 If Err Then
 	Err.Clear
 	On Error GoTo 0
 	Exit Sub
 End If
 Set oExcelBook = oExcelApplication.Workbooks.Add
 Set oExcelSheet = oExcelBook.Worksheets(1)
 
 'Creo le intestazioni del foglio excel	
 oExcelSheet.Range("A1").Value = "ID Ordine"
 oExcelSheet.Range("B1").Value = "ID Prodotto"
 oExcelSheet.Range("C1").Value = "Nome del prodotto"
 oExcelSheet.Range("D1").Value = "Totale dell'ordine"
 oExcelSheet.Range("A1:D1").Font.Bold = True
 
 Set rs = CreateObject("ADODB.Recordset")
 rs.Open sQuerySQL , cnsql
 'copio l'intero recordset all'interno dell'intervallo
 'prestabilito con il metodo CopyFromRecordset, comodo no!
 oExcelSheet.Range("A2").CopyFromRecordset rs
 Set rs = nothing       
 
 Set oExcelSheet = nothing
 'Salvo
 oExcelBook.SaveAs( sFileReport )
 
 Set oExcelBook = Nothing
 oExcelApplication.Quit
 Set oExcelApplication = Nothing
 On Error GoTo 0
 
End Sub
